#include <iostream>
#include <windows.h>
#include <cstdio>
#include <fstream>
#include <string>
using namespace std;


//initiations
void setcolor(unsigned short color)
{
	HANDLE hcon = GetStdHandle(STD_OUTPUT_HANDLE);
	SetConsoleTextAttribute(hcon,color);                                    
}

void codeerrorcheck()
{
ifstream fin;
fin.open("main.s");
setcolor(11);
if(!fin)
{
	setcolor(11);
	std::cout << "The main.s file doesn't exist. Compilation failed." << std::endl;
} else {
    std::cout << "Errors were found. The list is above." << std::endl;
    }
setcolor(13);
system("pause");
system("exit");
}

void gbaerrorcheck()
{
ifstream fin;
fin.open("main.out");
setcolor(11);
if(!fin)
{
	setcolor(11);
	std::cout << "The main.out file doesn't exist. Failed to make the main.out file." << std::endl;
} else {
    std::cout << "There are problems with main.out. Please fix your source code." << std::endl;
    }
setcolor(13);
system("pause");
system("exit");
}

int main() 
{
	system("del *.gba>nul");
	system("del *.o>nul");
   	system("del *.elf>nul");
   	system("del *.sav>nul");
	SetConsoleTitle("MakeROMGBA v1.9c");
	system("CLS");
	setcolor(110);
	std::cout << "MakeROM GBA tool created by imadog54. Scratch account is called imadog54." << std::endl;
	std::cout << "For this tool to work properly, your GBA Projects must all be organized in folders." << std::endl;
	std::cout << "The source file MUST be named 'main.s.'" << std::endl;
	std::cout << "\n";
	std::cout << "\n";
	std::cout << "\n";
	std::cout << "\n";
	setcolor(9);
	std::cout << "The ROM source code is being checked. Please wait a moment..." << std::endl;
	setcolor(12);
	Sleep(3000);
	int ret;
	if( !(ret = system("C:\\devkitPro\\devkitARM\\bin\\arm-none-eabi-gcc -mthumb-interwork -specs=gba.specs main.s")) ) {
		setcolor(10);
 		std::cout << "No errors were found. In the process, an .out file was created." << std::endl;
		std::cout << "\n";
	} else {
    	codeerrorcheck();
    	system("exit");
	}
	setcolor(9);
	std::cout << "Making GBA ROM file from the .out file..." << std::endl;
	setcolor(12);
	Sleep(3000);
	int ret3;
	if( !(ret3 = system("C:\\devkitPro\\devkitARM\\bin\\arm-none-eabi-objcopy -O binary a.out main.gba")) ) {
		setcolor(10);
 		std::cout << "ROM Built! " << std::endl;
 		std::cout << "\n";
	} else {
    	gbaerrorcheck();
    	system("exit");
	}
	system("C:\\devkitPro\\devkitARM\\bin\\gbafix main.gba");
	setcolor(93);
	system("PAUSE");;
   	system("cls");
	return 0;
}
